/*
 * Java-Gnome Bindings Library
 *
 * Copyright 1998-2002 the Java-Gnome Team, all rights reserved.
 *
 * The Java-Gnome Team Members:
 *   Jean Van Wyk <jeanvanwyk@iname.com>
 *   Jeffrey S. Morgan <jeffrey.morgan@bristolwest.com>
 *   Dan Bornstein <danfuzz@milk.com>
 *
 * The Java-Gnome bindings library is free software distributed under
 * the terms of the GNU Library General Public License version 2.
 *
 * This file was orriginally generated by the Java-GNOME Code Generator
 * Please do not modify the code that is identified as generated.  Also,
 * please insert your code above the generated code.
 *
 * Generation date: 2002-08-02 09:42:27 EDT
 */

#include <jni.h>
#include <sys/types.h>
#include <gtk/gtk.h>
#include <jg_jnu.h>
#include "gtk_java.h"

#include "org_gnu_gtk_TreeIter.h"
#ifdef __cplusplus
extern "C" 
{
#endif

static jobject getTreeIter(JNIEnv *env, GtkTreeIter *iter)
{
	return getGBoxedHandle(env, iter, GTK_TYPE_TREE_ITER, NULL,
        		(GBoxedFreeFunc) gtk_tree_iter_free);
}
/*
 * Class:     org_gnu_gtk_TreeModel
 * Method:    gtk_tree_model_get_string_from_iter
 * Signature: (II)Ljava/lang/String;
 */
JNIEXPORT jstring JNICALL Java_org_gnu_gtk_TreeIter_gtk_1tree_1model_1get_1string_1from_1iter
		(JNIEnv *env, jclass cls, jobject model, jobject iter)
{
    GtkTreeModel *model_g = (GtkTreeModel*)getPointerFromHandle(env, model);
    GtkTreeIter *iter_g = (GtkTreeIter*)getPointerFromHandle(env, iter);
    return (*env)->NewStringUTF(env, gtk_tree_model_get_string_from_iter(model_g, iter_g));
}

/*
 * Class:     org_gnu_gtk_TreeModel
 * Method:    gtk_tree_model_get_path
 * Signature: (II)I
 */
JNIEXPORT jobject JNICALL Java_org_gnu_gtk_TreeIter_gtk_1tree_1model_1get_1path
		(JNIEnv *env, jclass cls, jobject model, jobject iter)
{
    GtkTreeModel *model_g = (GtkTreeModel*)getPointerFromHandle(env, model);
    GtkTreeIter *iter_g = (GtkTreeIter*)getPointerFromHandle(env, iter);
    return getGBoxedHandle(env, gtk_tree_model_get_path(model_g, iter_g),
    		GTK_TYPE_TREE_PATH, NULL, (GBoxedFreeFunc) gtk_tree_path_free);
}

/*
 * Class:     org_gnu_gtk_TreeModel
 * Method:    gtk_tree_model_get_parent
 * Signature: (II)I
 */
JNIEXPORT jobject JNICALL Java_org_gnu_gtk_TreeIter_gtk_1tree_1model_1get_1parent
    (JNIEnv *env, jclass cls, jobject model, jobject child)
{
    GtkTreeModel *model_g = (GtkTreeModel*)getPointerFromHandle(env, model);
    GtkTreeIter *child_g = (GtkTreeIter*)getPointerFromHandle(env, child);
    GtkTreeIter *iter_g = (GtkTreeIter*)g_slice_alloc(sizeof(GtkTreeIter));
    gboolean value = gtk_tree_model_iter_parent(model_g, iter_g, child_g);
    if (TRUE == value)
        return getTreeIter(env, iter_g);
    else
        return (jobject)NULL;
}

/*
 * Class:     org_gnu_gtk_TreeModel
 * Method:    gtk_tree_model_iter_next
 * Signature: (II)I
 */
JNIEXPORT jobject JNICALL Java_org_gnu_gtk_TreeIter_gtk_1tree_1model_1iter_1next
		(JNIEnv *env, jclass cls, jobject model, jobject iter)
{
    GtkTreeModel *model_g = (GtkTreeModel*)getPointerFromHandle(env, model);
    GtkTreeIter *iter_g = (GtkTreeIter*)getPointerFromHandle(env, iter);
    gboolean value = gtk_tree_model_iter_next(model_g, iter_g);
    if (TRUE == value)
        return getTreeIter(env, iter_g);
    else
        return (jobject)NULL;
}

/*
 * Class:     org_gnu_gtk_TreeModel
 * Method:    gtk_tree_model_iter_children
 * Signature: (II)I
 */
JNIEXPORT jobject JNICALL Java_org_gnu_gtk_TreeIter_gtk_1tree_1model_1iter_1children
		(JNIEnv *env, jclass cls, jobject model, jobject parent)
{
    GtkTreeModel *model_g = (GtkTreeModel*)getPointerFromHandle(env, model);
    GtkTreeIter *parent_g = (GtkTreeIter*)getPointerFromHandle(env, parent);
    GtkTreeIter* iter = (GtkTreeIter*)g_slice_alloc(sizeof(GtkTreeIter));
    gboolean value = gtk_tree_model_iter_children(model_g, iter, parent_g);
    if (TRUE == value)
        return getTreeIter(env, iter);
    else
        return (jobject)NULL;
}

/*
 * Class:     org_gnu_gtk_TreeModel
 * Method:    gtk_tree_model_iter_has_child
 * Signature: (II)Z
 */
JNIEXPORT jboolean JNICALL Java_org_gnu_gtk_TreeIter_gtk_1tree_1model_1iter_1has_1child
		(JNIEnv *env, jclass cls, jobject model, jobject iter)
{
    GtkTreeModel *model_g = (GtkTreeModel*)getPointerFromHandle(env, model);
    GtkTreeIter *iter_g = (GtkTreeIter*)getPointerFromHandle(env, iter);
    return (jboolean)gtk_tree_model_iter_has_child(model_g, iter_g);
}

/*
 * Class:     org_gnu_gtk_TreeModel
 * Method:    gtk_tree_model_iter_n_children
 * Signature: (II)I
 */
JNIEXPORT jint JNICALL Java_org_gnu_gtk_TreeIter_gtk_1tree_1model_1iter_1n_1children
		(JNIEnv *env, jclass cls, jobject model, jobject iter)
{
    GtkTreeModel *model_g = (GtkTreeModel*)getPointerFromHandle(env, model);
    GtkTreeIter *iter_g = (GtkTreeIter*)getPointerFromHandle(env, iter);
    return (jint)gtk_tree_model_iter_n_children(model_g, iter_g);
}

/*
 * Class:     org_gnu_gtk_TreeModel
 * Method:    gtk_tree_model_iter_nth_child
 * Signature: (III)I
 */
JNIEXPORT jobject JNICALL Java_org_gnu_gtk_TreeIter_gtk_1tree_1model_1iter_1nth_1child
		(JNIEnv *env, jclass cls, jobject model, jobject parent, jint n)
{
    GtkTreeModel *model_g = (GtkTreeModel*)getPointerFromHandle(env, model);
    GtkTreeIter *parent_g = (GtkTreeIter*)getPointerFromHandle(env, parent);
    GtkTreeIter* iter = (GtkTreeIter*)g_slice_alloc(sizeof(GtkTreeIter));
    gboolean value = gtk_tree_model_iter_nth_child(model_g, iter, parent_g, (gint) n);
    if (TRUE == value)
        return getTreeIter(env, iter);
    else
        return (jobject)NULL;
}

/*
 * Class:     org_gnu_gtk_TreeModel
 * Method:    gtk_tree_model_iter_parent
 * Signature: (II)I
 */
JNIEXPORT jobject JNICALL Java_org_gnu_gtk_TreeIter_gtk_1tree_1model_1iter_1parent
		(JNIEnv *env, jclass cls, jobject model, jobject child)
{
    GtkTreeModel *model_g = (GtkTreeModel*)getPointerFromHandle(env, model);
    GtkTreeIter *child_g = (GtkTreeIter*)getPointerFromHandle(env, child);
    GtkTreeIter* parent = (GtkTreeIter*)g_slice_alloc(sizeof(GtkTreeIter));
    gboolean value = gtk_tree_model_iter_parent(model_g, parent, child_g);
    if (TRUE == value)
        return getTreeIter(env, parent);
    else
        return (jobject)NULL;
}
                                                
/*
 * Class:     org.gnu.gtk.TreeIter
 * Method:    gtk_tree_iter_get_type
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_org_gnu_gtk_TreeIter_gtk_1tree_1iter_1get_1type (JNIEnv *env, jclass cls) 
{
    return (jint)gtk_tree_iter_get_type ();
}

/*
 * Class:     org.gnu.gtk.TreeIter
 * Method:    gtk_tree_iter_free
 * Signature: (I)V
 */
JNIEXPORT void JNICALL Java_org_gnu_gtk_TreeIter_gtk_1tree_1iter_1free
		(JNIEnv *env, jclass cls, jobject iter) 
{
    GtkTreeIter *iter_g = (GtkTreeIter *)getPointerFromHandle(env, iter);
    gtk_tree_iter_free (iter_g);
}

#ifdef __cplusplus
}

#endif
